#include <string.h>
#include <process.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <conio.h>
#include "estad.h"

boolean imp_d, imp_r;
nat clase, clase_vie = -1, alg;
nat muestra;

void main(int argc, char *argv[])
{

   int bench;
   char alg_vie[MAX_NOM_ALG], nombre[MAX_NOM_ALG];
   int i;

   verif_args(argc, argv);

   resum = fopen("result.txt", "at");

   for (bench = 0; bench < CANT_T_BENCH; bench++) { /* agarro BM x BM */
     nombre[0]='\0';
     strcpy(nombre, nom_bench[bench]);
     strcat(nombre,".ord");
     arch = fopen(nombre, "rt");
	if (arch == NULL) exit(0);

   alg = 0;    /* Empiezo por el primer algoritmo */  /* OJO!!! */
   leer_datos(arch);  /* carga en metricas */
  //  clase = clase * 20 / 30;   /* Volarlo!!! */

   while (!feof(arch)) {
     strcpy(alg_vie, metricas.alg);
     clase_vie = clase;
     inicializar_res();
     muestra = 0;

     while ((strcmp(alg_vie,metricas.alg)==0) && (clase_vie == clase)
			&& (!feof(arch))) {
	if (clase <= 30) { /* Cambiarlo por 30 */
		muestra++;
		if (imp_d) imprimir_resultados();
		strcpy(alg_vie, metricas.alg);
		actualizar_res();
	}
	clase_vie = clase;
	leer_datos(arch);
	// clase = clase * 20 / 30;   /* Volarlo!!! */
     } /* while alg_vie */
//     clrscr();
//     printf("Procesando lote %d", i++);
     if (clase <= 30) { /* Cambiarlo por 30 */
	guardar_res_bench(bench);  /* Graba los datos de los algoritmos en res */
	if (imp_r) imprimir_resumen(); /* Imprime el resumen por pantalla */
     }
     if (strcmp(alg_vie, metricas.alg) != 0) alg++; /* Cambio de algoritmo */
  } /* while !feof */
  printf("Fin Benchmark %s", nom_bench[bench]);
  fclose(arch);
 } /* for bench */
}

void leer_datos(FILE *arch) {

   char buffer[MAX_STRING];
   int i, j;
   char *err;
   int buscar_coma(char*, int);

		err = fgets(buffer, MAX_STRING, arch);
		// while(buffer[i] != ',')
		for(i=0; i<5; i++)
		   metricas.alg[i] = buffer[i];
		i--;

		j = buscar_coma(buffer, i);
		clase = atoi(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.remocion = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.c_contexto = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.uso_cpu = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.Un = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		for(i=0; i<2; i++)
		   metricas.overloaded[i] = buffer[j++];

		j = buscar_coma(buffer, j);
		metricas.nr_metas = atoi(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.idle_time = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.g_r = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.g_r_pond = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.g_r_per = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.g_r_per_pond = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.g_r_aper = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.g_r_aper_pond = (float) atof(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.metas_perd = atoi(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.metas_per = atoi(&buffer[j]);

		j = buscar_coma(buffer, j);
		metricas.metas_aper = atoi(&buffer[j]);

}

int buscar_coma(char *buffer, int j) {

  while (buffer[j++] != ',');
  return j;
}

void imprimir_resultados() {

	printf("\n----------------------------------------------------------------\n");
	printf("Algoritmo: %5s, ", metricas.alg);
	printf("Clase: %u, ", clase);
	printf("Remociones: %g, Cambio de contexto: %g\n", metricas.remocion, metricas.c_contexto);
	printf("Uso CPU: %g, U(n): %g, ", metricas.uso_cpu, metricas.Un);
	printf("Overload: %s, Cant_metas: %u, ", metricas.overloaded, metricas.nr_metas);
	printf("Idle time: %g \n", metricas.idle_time);
	printf("G.R.: %g,", metricas.g_r);
	printf("G.R. pond. : %g \n", metricas.g_r_pond);

	printf("G.R. per: %g, G.R. Per. Pond.:%g \n", metricas.g_r_per, metricas.g_r_per_pond);
	printf("G.R. aper: %g, G.R. aper. pond: %g \n", metricas.g_r_aper,metricas.g_r_aper_pond);
	printf("Metas perdidas: %u, Periodicas: %u, Aperiodicas: %u\n", metricas.metas_perd, metricas.metas_per, metricas.metas_aper);

}


void actualizar_res() {  /* Toma las metricas y actualiza el resumen */
	strcpy(t_res.alg, metricas.alg);
	t_res.clase = clase;

	calcula_float(&t_res.min_rem, &t_res.max_rem, &t_res.avg_rem, &t_res.std_rem,
		metricas.remocion);

	calcula_float(&t_res.min_uso, &t_res.max_uso,&t_res.avg_uso, &t_res.std_uso,
		metricas.uso_cpu);

	calcula_float(&t_res.min_cc, &t_res.max_cc, &t_res.avg_cc, &t_res.std_cc,
		metricas.c_contexto);

	calcula_float(&t_res.min_idle, &t_res.max_idle, &t_res.avg_idle, &t_res.std_idle,
		(float) metricas.idle_time);

	if (metricas.g_r != 2.0)
	calcula_float(&t_res.min_gr, &t_res.max_gr, &t_res.avg_gr, &t_res.std_gr,
		(float) metricas.g_r);

	if (metricas.g_r_per != 2.0)
	calcula_float(&t_res.min_gr_per, &t_res.max_gr_per, &t_res.avg_gr_per, &t_res.std_gr_per,
		metricas.g_r_per);

	if (metricas.g_r_aper != 2.0)
	calcula_float(&t_res.min_gr_aper, &t_res.max_gr_aper, &t_res.avg_gr_aper, &t_res.std_gr_aper,
		metricas.g_r_aper);

	if (metricas.g_r_pond != 2.0)
	calcula_float(&t_res.min_gr_pond, &t_res.max_gr_pond, &t_res.avg_gr_pond, &t_res.std_gr_pond,
		metricas.g_r_pond);

	if (metricas.g_r_per_pond != 2.0)
	calcula_float(&t_res.min_gr_per_pond, &t_res.max_gr_per_pond, &t_res.avg_gr_per_pond, &t_res.std_gr_per_pond,
		metricas.g_r_per_pond);

	if (metricas.g_r_aper_pond != 2.0)
	calcula_float(&t_res.min_gr_aper_pond, &t_res.max_gr_aper_pond, &t_res.avg_gr_aper_pond, &t_res.std_gr_aper_pond,
		metricas.g_r_aper_pond);
}

void calcula_int(nat *vmin, nat *vmax, float *vavg, float *vstd, unsigned int dato) {

	if (dato > 1.0) {
	   // printf("Error en algoritmo %s, muestra %d, clase %d\n",
	   //	lista_alg[alg], muestra, clase);
	   return;
	}
	*vmin = min(*vmin, dato);
	*vmax = max(*vmax, dato);
	if (*vavg == 0)
		*vavg = dato;
	else
		*vavg = avg(*vavg, dato);
	*vstd = std(*vstd, dato, *vavg);
}


void calcula_float(float *vmin, float *vmax, float *vavg, float *vstd, float dato) {

	if (dato > 1.0) {
	   // printf("Error en algoritmo %s, muestra %d, clase %d\n",
	   //	lista_alg[alg], muestra, clase);
	   return;
	}

	*vmin = min(*vmin, dato);
	*vmax = max(*vmax, dato);
	if (*vavg == 0)
		*vavg = dato;
	else
		*vavg = avg(*vavg, dato);

	*vstd = std(*vstd, dato, *vavg);
}


void inicializar_res() {
/* Pone todo lo anterior en cero. */

    strcpy(t_res.alg, "");
	 t_res.min_rem = UINT_MAX;    /* Como calculo minimo, pongo valor maximo */
    t_res.avg_rem = t_res.std_rem = 0;
	 t_res.min_uso = 1e20;
    t_res.avg_uso = t_res.std_uso = 0.;
	 t_res.min_idle = 1e20;
    t_res.avg_idle = t_res.std_idle = 0.;
	 t_res.min_cc = UINT_MAX;
	 t_res.avg_cc = t_res.std_cc = 0;
    t_res.min_gr = 1e20;
	 t_res.avg_gr = t_res.std_gr = 0.;
    t_res.min_gr_per = 1e20;
	 t_res.avg_gr_per = t_res.std_gr_per = 0.;
    t_res.min_gr_aper = 1e20;
	 t_res.avg_gr_aper = t_res.std_gr_aper = 0.;
    t_res.min_gr_pond = 1e20;
	 t_res.avg_gr_pond = t_res.std_gr_pond = 0.;
    t_res.min_gr_per_pond = 1e20;
	 t_res.avg_gr_per_pond = t_res.std_gr_per_pond = 0.;
    t_res.min_gr_aper_pond = 1e20;
	 t_res.avg_gr_aper_pond = t_res.std_gr_aper_pond = 0.;

    t_res.max_rem = t_res.max_uso = t_res.max_cc = t_res.max_idle = 0;
    t_res.max_gr = t_res.max_gr_aper = t_res.max_gr_pond = 0;
    t_res.max_gr_aper_pond = 0;   /* Los maximos empiezxan en 0 */
}


void imprimir_resumen() {

	printf("--------------------------------------------------------------\n");
	printf("Resumen Algoritmo: %s \n", t_res.alg);
	printf("Clase: %u \n", t_res.clase);

	printf("Remociones-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g\n",
		t_res.min_rem, t_res.max_rem, t_res.avg_rem, sqrt(t_res.std_rem));

	printf("Uso CPU-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g \n",
	     t_res.min_uso, t_res.max_uso, t_res.avg_uso, sqrt(t_res.std_uso));

	printf("Cambios de contexto-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g \n",
		t_res.min_cc, t_res.max_cc, t_res.avg_cc, sqrt(t_res.std_cc));

	printf("Idle time-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g \n",
		t_res.min_idle, t_res.max_idle, t_res.avg_idle, sqrt(t_res.std_idle));

	printf("G.R.-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g \n",
		t_res.min_gr, t_res.max_gr, t_res.avg_gr, sqrt(t_res.std_gr));

	printf("G.R. Per.-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g \n",
		t_res.min_gr_per, t_res.max_gr_per, t_res.avg_gr_per, sqrt(t_res.std_gr_per));

	printf("G.R. Aper.-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g\n",
		t_res.min_gr_aper, t_res.max_gr_aper, t_res.avg_gr_aper, sqrt(t_res.std_gr_aper));

	printf("G.R. Pond.-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g \n",
		t_res.min_gr_pond, t_res.max_gr_pond, t_res.avg_gr_pond, sqrt(t_res.std_gr_pond));

	printf("G.R. Pond. Per.-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g\n",
		t_res.min_gr_per_pond, t_res.max_gr_per_pond, t_res.avg_gr_per_pond, sqrt(t_res.std_gr_per_pond));

	printf("G.R. Pond. Aper.-min:%-8.5g, max:%-8.5g, avg:%-8.5g, std:%-8.5g\n",
		t_res.min_gr_aper_pond, t_res.min_gr_aper_pond, t_res.avg_gr_aper_pond, sqrt(t_res.std_gr_aper_pond));

	printf("Tamao de la muestra: %u\n", muestra);

	printf("---------------------------------------------------------------------\n");
}


void guardar_res_bench(int bench) {
  int i;
  boolean hay;

	if (t_res.alg[0] == NULL) return;   // Seguridad
	for (i=0; i<5; i++)
	   if (t_res.alg[i] != ' ')
	      hay = TRUE;

	if (!hay) return;

	fprintf(resum, "%5s,", t_res.alg);

	fprintf(resum, "%02u,", t_res.clase);
	fprintf(resum, "%s,", nom_bench[bench]);

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_rem, t_res.max_rem, t_res.avg_rem, sqrt(t_res.std_rem));

	fprintf(resum, "%g,%g,%g,%g,",
	     t_res.min_uso, t_res.max_uso, t_res.avg_uso, sqrt(t_res.std_uso));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_cc, t_res.max_cc, t_res.avg_cc, sqrt(t_res.std_cc));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_idle, t_res.max_idle, t_res.avg_idle, sqrt(t_res.std_idle));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_gr, t_res.max_gr, t_res.avg_gr, sqrt(t_res.std_gr));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_gr_per, t_res.max_gr_per, t_res.avg_gr_per, sqrt(t_res.std_gr_per));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_gr_aper, t_res.max_gr_aper, t_res.avg_gr_aper, sqrt(t_res.std_gr_aper));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_gr_pond, t_res.max_gr_pond, t_res.avg_gr_pond, sqrt(t_res.std_gr_pond));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_gr_per_pond, t_res.max_gr_per_pond, t_res.avg_gr_per_pond, sqrt(t_res.std_gr_per_pond));

	fprintf(resum, "%g,%g,%g,%g,",
		t_res.min_gr_aper_pond, t_res.min_gr_aper_pond, t_res.avg_gr_aper_pond, sqrt(t_res.std_gr_aper_pond));
	fprintf(resum, "%u\n", muestra);
}


void verif_args(int argc, char*argv[]) {

   char opc;

   imp_d = imp_r = FALSE;

   if (argc==1) return;

	 while (argc-- != 1) {  /* Tomo todos los argumentos de atra's a adelante */
	opc = argv[argc][1];
	switch(opc) {
		case 'i':
		case 'I':
		   switch (argv[argc][3]) {

			case 'n':
			case 'N': break;

			case 'd':
			case 'D': imp_d = TRUE; break;

			case 'r':
			case 'R': imp_r = TRUE; break;

			default : imp_r = imp_d = TRUE;
			}
			break;

	       default: printf("Formato incorrecto. Debe ingresar \n");
	       printf("estad [opcion de impresion]\n");
		       exit(-1);
       }
   }
}


