/* estad.h. Encabezados para el generador de estadisticas */
#include <stdio.h>
#include "nombres.h"

/* Macros */

#define std(s,a,x)  ((s) + ((a)-(x)) * ((a)-(x)) / 2)   /* Macro: desvio std. de s y a. */
#define avg(Ti,ti)  ((Ti) * 0.7 + (ti) * 0.3)

/* Tipos nuevos */

typedef unsigned short crit;
typedef unsigned int nat;
enum bool {FALSE,TRUE};
enum clase {PER, APER};
typedef enum bool boolean;

struct {
    char alg[MAX_NOM_ALG];       /* Algoritmo usado */
	 float remocion, c_contexto, idle_time;
    float uso_cpu;              /* % Ci/Ti */
    float Un;                   /* U(n) */
    char overloaded[3];
	 nat nr_metas;    /*  Numero total de metas */
    float g_r, g_r_pond,
	  g_r_per, g_r_per_pond,
	  g_r_aper, g_r_aper_pond;
    nat metas_perd, metas_per, metas_aper;
} metricas;


struct {
    char alg[MAX_NOM_ALG];       /* Algoritmo usado */
    nat clase;
    float min_rem, min_cc, min_idle, max_rem, max_cc, max_idle;
    float avg_rem,std_rem,
	  avg_cc, std_cc,
	  avg_idle, std_idle,
	  avg_uso, std_uso, min_uso, max_uso,
	  avg_gr, std_gr, min_gr, max_gr,
	  avg_gr_per, std_gr_per, min_gr_per, max_gr_per,
	  avg_gr_aper, std_gr_aper, min_gr_aper, max_gr_aper,
	  avg_gr_pond, std_gr_pond, min_gr_pond, max_gr_pond,
	  avg_gr_per_pond, std_gr_per_pond, min_gr_per_pond, max_gr_per_pond,
	  avg_gr_aper_pond, std_gr_aper_pond, min_gr_aper_pond, max_gr_aper_pond;
} t_res;      /*  Tabla de resultados */

/* Variables globales */

/* a) Archivos */
FILE *arch, *resum;

/* b) Funciones */
void imprimir_resultados(void);
void guardar_resultados(void);
void inicializar_res(void);
void actualizar_res(void);
void guardar_res_bench(int bench);
void calcula_int(nat *vmin, nat *vmax, float *vavg, float *vstd, unsigned int dato);
void calcula_float(float *vmin, float *vmax, float *vavg, float *vstd, float dato);
void imprimir_resumen(void);
void verif_args(int argc, char*argv[]);
void leer_datos(FILE *);
