Option Explicit
'pathDB guarda el path de la base de datos actualmente utilizada
Global pathDB As String
Global serieactual As Integer

'declaraciones para la api
Declare Function WinExec Lib "Kernel" (ByVal lpCmdLine As String, ByVal nCmdShow As Integer) As Integer
Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOW = 5
Global Const SW_HIDE = 0

'field type constants
Global Const FT_TRUEFALSE = 1
Global Const FT_BYTE = 2
Global Const FT_LONG = 4
Global Const FT_CURRENCY = 5
Global Const FT_SINGLE = 6
Global Const FT_DOUBLE = 7
Global Const FT_DATETIME = 8
Global Const FT_STRING = 10
Global Const FT_BINARY = 11
Global Const FT_MEMO = 12
Global Const FT_INTEGER = 3

'una activacion es un segmento continuo de ejecucin de un proceso
Type activacion
    numtarea As Integer
    comienzo As Integer
    fin As Integer
    flag As Integer
End Type

'un fallo es una perdida de meta de una tarea
Type fallo
    tarea As Integer
    time As Integer
End Type

'archivos intermedios de algoritmos y nombres de bm's
' para harts y estad
Global ARCHALGS As String
Global ARCHBENCHS As String

' la corrida es un conjunto de ejecuciones de procesos
Global corrida(100) As activacion
Global nMaxActi As Integer

Global nombresTareas(1 To 20) As String 'nombres de las tareas
Global nMaxTareas As Integer 'cantidad de tareas

Global falloMeta(50) As fallo 'posiciones donde hubo fallos
Global nMaxFallos As Integer 'cantidad de fallos

Global Const MargenHori = 0
Global Const margenVer = 0

'Guarda el nombre del .pif que arranca el DOS ( Win95ready)
Global Const pifName = "dos31.pif"

'declaraciones para el help
Declare Function WinHelp Lib "User" (ByVal hWnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, dwData As Any) As Integer



Function fileOpen () As String
    Dim i As Integer
    Dim j As Integer
    Dim extension As String

    On Error Resume Next
    Dim OpenFileName As String
    MDIform1.CMDialog1.Filename = ""
    MDIform1.CMDialog1.Filter = "Base de datos (*.mdb)|*.mdb"
     
    MDIform1.CMDialog1.Action = 1
    If Err <> 32755 Then 'user pressed cancel
        OpenFileName = MDIform1.CMDialog1.Filename
        fileOpen = OpenFileName
    End If
End Function

Function GetFieldWidth (t As Integer)
  'determines the form control width
  'based on the field type
  Select Case t
    Case FT_TRUEFALSE
      GetFieldWidth = 850
    Case FT_BYTE
      GetFieldWidth = 650
    Case FT_INTEGER
      GetFieldWidth = 900
    Case FT_LONG
      GetFieldWidth = 1100
    Case FT_CURRENCY
      GetFieldWidth = 1800
    Case FT_SINGLE
      GetFieldWidth = 1800
    Case FT_DOUBLE
      GetFieldWidth = 2200
    Case FT_DATETIME
      GetFieldWidth = 2000
    Case FT_STRING
      GetFieldWidth = 3250
    Case FT_BINARY
      GetFieldWidth = 3250
    Case FT_MEMO
      GetFieldWidth = 3250
    Case Else
      GetFieldWidth = 3250
  End Select

End Function

Sub graficarcorrida2 ()
    Dim py As Integer
    Dim i As Integer
    Dim sh As Integer  'reemplazos para picture1.ScaleWidth
    Dim sw As Integer  'para tener mas velocidad
    Dim c As Long 'color
    Dim aux As Integer
    Dim de As Integer
    Dim ha As Integer

    'formTiempos.Show
    de = Val(formhart.Desde.Text)
    ha = Val(formhart.Hasta.Text)
    
   ' formTiempos.Picture1.ScaleTop = 1
    formTiempos.Picture1.ScaleLeft = de
    formTiempos.Picture1.ScaleHeight = nMaxTareas + margenVer + 1
    formTiempos.Picture1.ScaleWidth = ha - de
    
    sh = formTiempos.Picture1.ScaleHeight
    sw = formTiempos.Picture1.ScaleWidth

    formTiempos.Picture1.Cls

    'grillado
    aux = Val(formhart.grilla.Text)
    i = 0
    Do While aux * i + de <= ha
        formTiempos.Picture1.Line (aux * i + de + MargenHori, 0)-(aux * i + de + MargenHori, .2)
        formTiempos.Picture1.Print aux * i + de
        formTiempos.Picture1.DrawStyle = 2
        formTiempos.Picture1.Line (aux * i + de + MargenHori, .2)-(aux * i + de + MargenHori, sh)
        formTiempos.Picture1.DrawStyle = 0
        i = i + 1
    Loop

    For i = 1 To nMaxTareas
        formTiempos.Picture1.Line (de, i + margenVer)-(de + .2, i + margenVer)
        formTiempos.Picture1.Print nombresTareas(i)
    Next i

    For i = 0 To nMaxActi
        py = corrida(i).numtarea + margenVer
        If i < nMaxActi Then 'si hay siguiente veo si fue remocin
            If corrida(i + 1).flag = 0 Then c = BLACK Else c = BLUE
        Else
            c = BLACK
        End If
        formTiempos.Picture1.Line (corrida(i).comienzo + MargenHori, py)-(corrida(i).fin + MargenHori, py + .5), c, B
    Next i

    For i = 1 To nMaxFallos
        formTiempos.Picture1.Line (falloMeta(i).time + MargenHori, falloMeta(i).tarea + margenVer)-(falloMeta(i).time + MargenHori, falloMeta(i).tarea + margenVer + .5), RED
    Next i

End Sub

Function loadGrid (grd As Control, FDS As Snapshot, dynst$, start&) As Integer
   Dim ft As Integer               'tipo de campo
   Dim i As Integer, j As Integer
   Dim fn As String                'nombre del campo
   Dim rc As Integer               'contador de registros
   Dim gs As String                'grid string

   Dim auxWidth As Integer

   On Error GoTo LGErr

   
   'setup the grid
   grd.Rows = 2       'reduce the grid
   grd.FixedRows = 0  'allow next step
   grd.Rows = 1       'limpia la grilla completamente
   grd.Cols = FDS.Fields.Count + 1

   If start& = 0 Then
     On Error Resume Next
     'setea el ancho de las columnas
     For i = 0 To FDS.Fields.Count - 1
       ft = FDS(i).Type
       If ft = FT_STRING Then
     If FDS(i).Size > Len(FDS(i).Name) Then
       'auxWidth = FormBd.TextWidth("A")
       'con esta linea que comento no se por que me abre
       'otro form asi que la reemplazo por el valor que devuelve
       auxWidth = 135
       If FDS(i).Size <= 10 Then
         grd.ColWidth(i + 1) = FDS(i).Size * auxWidth
       Else
         grd.ColWidth(i + 1) = 10 * auxWidth
       End If
     Else
       If Len(FDS(i).Name) <= 10 Then
         grd.ColWidth(i + 1) = Len(FDS(i).Name) * auxWidth
       Else
         grd.ColWidth(i + 1) = 10 * auxWidth
       End If
     End If
       ElseIf ft = FT_MEMO Then
     grd.ColWidth(i + 1) = 1200
       Else
     grd.ColWidth(i + 1) = GetFieldWidth(ft)
       End If
     Next

     On Error GoTo LGErr
     'carga los nombres de los campos
     grd.Row = 0
     For i = 0 To FDS.Fields.Count - 1
       grd.Col = i + 1
       grd.Text = UCase(FDS(i).Name)
     Next
   End If

   rc = 1
   'gtn
   FDS.MoveFirst
   'gtn fin : se lo agrego porque si no no entra al while
   'agrega los registros a la grilla
   While FDS.EOF = False
     gs = CStr(rc + start) + Chr$(9)
     For i = 0 To FDS.Fields.Count - 1
       If FDS(i).Type = FT_MEMO Then
     If FDS(i).FieldSize() < 255 Then
       gs = gs + StripNonAscii(vFieldVal(FDS(i))) + Chr$(9)
     Else
       'solo puede tomar los primeros 255 caracteres
       gs = gs + StripNonAscii(vFieldVal(FDS(i).GetChunk(0, 255))) + Chr$(9)
     End If
       ElseIf FDS(i).Type = FT_STRING Then
     gs = gs + StripNonAscii(vFieldVal(FDS(i))) + Chr$(9)
       Else
     gs = gs + vFieldVal(FDS(i)) + Chr$(9)
       End If
     Next
     gs = Mid(gs, 1, Len(gs) - 1)
     grd.AddItem gs
     FDS.MoveNext
     rc = rc + 1
   Wend

   grd.FixedRows = 1   'freeze the field names
   grd.FixedCols = 1   'freeze the row numbers
   grd.Row = 1         'set current position
   grd.Col = 1

   loadGrid = rc       'return number added
   GoTo LGEnd

LGErr:
'   ShowError
   loadGrid = False    'return 0
   Resume LGEnd

LGEnd:
  ' MsgBar "", False

End Function

Sub resetGrafico ()
    serieactual = 0
    formgrafico!grafico.DataReset = 1
    formgrafico!grafico.DataReset = 5
    formgrafico!grafico.RandomData = 0
    formgrafico!grafico.DrawMode = 2
    formDatos!Grid1.Visible = False

End Sub

Function StripNonAscii (vs As Variant) As String
  Dim i As Integer
  Dim ts As String

  For i = 1 To Len(vs)
    If Asc(Mid(vs, i, 1)) < 32 Or Asc(Mid(vs, i, 1)) > 126 Then
      ts = ts + " "
    Else
      ts = ts + Mid(vs, i, 1)
    End If
  Next

  StripNonAscii = ts

End Function

Function vFieldVal (fval As Variant) As Variant
  If IsNull(fval) Then
    vFieldVal = ""
  Else
    vFieldVal = CStr(fval)
  End If
End Function

