#include <string.h>
#include <process.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <conio.h>
#include <time.h>
#include "tr.h"

/********
* defines
*
*   AGAPE   si va a ser usado con la interfase agape debe definirse.
*
*/

#ifdef AGAPE
const int TECLA_EXIT=32;
FILE *fileAgape;
char lineaAgape[50],lineaFin[50],*lineaRemo;
nat horaAnt=0,horaActual=0;
int tecla=FALSE;
#endif

void main(int argc, char *argv[])
{
   int nr_alg = -1, bench;
   char nombre_alg[MAX_NOM_ALG], archi[MAX_STRING];

   verif_args(argc, argv, nombre_alg, archi); /* Elijo que' voy a mostrar */
   randomize();

/*
   bench = 9;
   while (1) {
	archi[0] = '\0';
	gen_tbl_Hartstone=tbl_bench[bench];
	printf("%s, %d", nom_bench[bench], bench);
	init(archi);
	getchar();
	if (paro){ bench++;
	  printf("Para\n");
	  paro = FALSE;
	  bm_ovl = FALSE;
	  getchar();
	  }
   }
   return;
*/
   for (bench=0; bench< CANT_T_BENCH ; bench++) { /* Distintos BM */

	// if (bench < 6 || bench > 6) continue;
	/* Aqui' viene co'digo para seleccionar el Benchmark a correr */

	nro_tasks=0;
	paro = FALSE;
	bm_ovl = FALSE;
	res = fopen(nom_bench[bench], "at");  /* Abro el archivo del BM */
	gen_tbl_Hartstone=tbl_bench[bench];  /* Elijo el BM */
	printf("\nb:%02d", bench);

    while (!paro) { /* Sorecargo los benchmarks hasta cierto punto */
       if (imp_t) printf("\n%s:\n", nom_bench[bench]);
	   init(archi);				/* Inicializo tablas */
	   salvar_TBCP();   /* Guardo la tabla: las aperiodicas la rompe */
	   if (imp_t) printf("Hasta: %u, Tareas: %d", hasta_cuando, nro_tasks);

	   for (nr_alg=0; nr_alg< MAX_ALG ; nr_alg++) { /* Simulo para c/alg. */
		if (nr_alg < 3) continue;

		/* Segun que algoritmo este' usando, la gamma usada */
		if (nr_alg > 8)
		   que_gama = CERCA_CERO;
		else
		   que_gama = CERCA_PEOR;

	       /* Aqui' viene co'digo para elegir el algoritmo a simular */
	       anterior = -1;

	       inicializar_mediciones();  /* reseteo metricas locales */
	       nr_alg = seleccionar_algoritmo(nr_alg, nombre_alg);
	       suma_previos = 0;
	       verificar_planif();      /* mira la relacin de planificabilidad */
	       /* En cuanto miro la planificabilidad, establezco la clase */
	       /* Son 30 clases, entre 0 y 3 */
	       clase = metricas.uso_cpu * 10;

	       if (metricas.uso_cpu > 3.5) {
			paro = TRUE;  /* No quiero sobrecarga > 300 % */
			break;
	       }

	       if (overloaded) set_conj_crit();
	       /* Si existe overload: selecciona las del conjunto critico */

	       strcpy(metricas.alg, lista_alg[nr_alg]);
	       simulador();        /* Simulo */
#ifdef AGAPE
           paro = tecla;
#endif
	       if (nombre_alg[0] != NULL) exit(0); /* Un solo algoritmo */
	       restaurar_TBCP();               /* Recupero la TBCP */
	   } /* for algoritmos */
	if (archi[0] != NULL) exit(0);   /* Un archivo: no genero + tablas */
	}  /* while */
     fclose(res);
#ifdef AGAPE
     if (tecla) break;
#endif

     } /* for tipo benchmark */
} /* main */


/* ---------------------    Funciones Hartstone   -------------------------
  En cada Benchmark se genera una tabla inicial, y se hacen corridas poste-
  riores sobrecargando el conjunto de tareas ejecutadas.
  ******************************** PA *************************************/

void PA1() {

/* 5 tareas armonicas. Ci=1. Aumento el Ci hasta que lleguen a ser iguales
con algun Ti. Las armonicas se generan, tomando al azar las posiciones de la
tabla y generando otro numero al azar; luego multiplicando por el anterior */

 nat valor = 5, i, j;

   if (bm_ovl) { /* En las siguientes llamadas aumento el Ci */
	BCP[j = random(4)].Ci += 5;
	if (BCP[j].Ci + 5 > BCP[j].Ti) {
		BCP[j].Ci = BCP[j].Ti;
		paro = TRUE;
	}
	return;
   }

   /* 1er. test */
   for (i=0; i<5; i++) {  /* Inicializo tabla (5 tareas armo'nicas) */
	valor *= (random(5)+1);
	BCP[i].Ti = valor;
	BCP[i].Ci = 1;
	BCP[i].criticidad = (float) random(30000)/30000.0;
	BCP[i].tipo = PER;
   }
   nro_tasks= cant_per =i;
   bm_ovl = TRUE;
   hasta_cuando = valor;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void PA2() {

/* 5 tareas armonicas. Ci < Ti. Aumentar Ti de varias hasta que llegue a ser
igual que Ci. Genera las cargas al reves: primero las muy cargadas, y luego
las poco cargadas */

 static nat valor;
 int i, j;

  if (bm_ovl) {  /* Aumento el Ti, relajando las restricciones del sistema */
	j = random(5); if (j == 5) j=4;
	valor *= (random(3)+1);
	BCP[j].Ti = valor;
	if (valor >= 32000) paro = TRUE; /* Seguridad del tipo de datos +  */
	hasta_cuando = valor;            /* reducir long. de la simulacio'n */
	return;
  }

  /* 1er. test */
  valor = 5;
  for (i=0; i<5; i++) {   /* 5 tareas armo'nicas */
    valor *= (random(2)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = valor*3/5;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = i;
  bm_ovl = TRUE;
  hasta_cuando = valor;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void PA3() {

/* 5 tareas armonicas. Ci < Ti. Disminuir Ti de una tarea hasta que llegue a
   ser igual que Ci */

 static nat valor = 5, j;
 int i;

  if (bm_ovl) {
	while (valor == BCP[j].Ti)         /* Que no haga 2 repetidos */
		valor *= (random(2)+1);
	BCP[j].Ti = valor;
	if (valor >= 32000) paro = TRUE;
	hasta_cuando = valor;
	return;
  }

  /* 1er. test */
  for (i=0; i<5; i++) {
    valor *= (random(2)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = valor*2/5;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = i;
  bm_ovl = TRUE;
  hasta_cuando = valor;
  j = random(4);
  BCP[j].Ci *=2; /* Para que el sistema este mas sobrecargado en esa tarea */
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void PA4() {
/* Agregar de a una tarea periodica a la vez. */

  static nat pos = 5, valor = 5;
  int i, j;

  if (bm_ovl) {    /* Agrego una tarea perio'dica */
	j = (random(2)+1); if (j == 3) j = 2;
	valor *=j;
	BCP[pos].Ti = valor;
	BCP[pos].Ci = random(BCP[pos].Ti)/5+1;
	BCP[pos].criticidad = (float) random(30000)/30000.0;
	BCP[pos].tipo = PER;
	BCP[pos].comienzo = 0;
	pos++;
	nro_tasks++;
	if (nro_tasks > 40 || valor > 32000) {
	      if (valor > 32000) BCP[pos].Ci = random(30000)+1;
	      if (BCP[pos].Ci > BCP[pos].Ti) BCP[pos].Ci = BCP[pos].Ti/10;
	      paro = TRUE;
	}
	hasta_cuando = valor;
	return;
  }

  for (i=0; i<5; i++) {
    valor *= (random(5)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti)/15+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks= cant_per = i;
  bm_ovl = TRUE;
  hasta_cuando = valor;
}

/********************************** PN *************************************/
void PN1() {  /* 5 no armonicas. Ci aumenta en las siguientes corridas. */
 int i, j;
 int val_in = 5;

   if (bm_ovl) { /* En las siguientes llamadas aumento el Ci */
	j = random(4);
	if (BCP[j].Ci + 10 >= BCP[j].Ti) {
		BCP[j].Ci = BCP[j].Ti;
		paro = TRUE;
		return;
	}
	BCP[j].Ci += 10;
	return;
   }

   /* 1er. test */
   for (i=0; i<5; i++) {  /* Al principio inicializo tabla (5 tareas) */
	BCP[i].Ti = (random(20)+1)*val_in;
	BCP[i].Ci = BCP[i].Ti/10+1;
	BCP[i].criticidad = (float) random(30000)/30000.0;
	BCP[i].tipo = PER;
   }
   nro_tasks=cant_per=i;
   bm_ovl = TRUE;
   hasta_cuando = maximo();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void PN2() {

/* 5 tareas no armonicas. Ci: al azar, < Ti. Disminuir Ti hasta que
llegue a ser igual que Ci */

 nat valor = 5, i, j;
 static boolean cuales[5];

 if (bm_ovl) {

	do {   /* Sigo hasta que encuentra uno en el se pueda restar */
	   j=random(5);
	   if (j==5) j=4;

	   paro = TRUE;
	   for (i=0; i<5; i++)
	       if (cuales[i] == FALSE) paro = FALSE;

	   if (paro) return;

	} while (cuales[j] == TRUE);

	if (BCP[j].Ti - BCP[j].Ci <= 70)  {
		BCP[j].Ti = BCP[j].Ci;
		cuales[j] = TRUE;
	}
	else
		BCP[j].Ti-= 70;

/*	if (BCP[j].Ti - BCP[j].Ci <= 5) paro = TRUE; */
	hasta_cuando = maximo();
	return;
  }

  /* 1er. test */
  for (i=0; i<5; i++) {
    valor *= (random(5)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti-1)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = i;
  bm_ovl = TRUE;
  hasta_cuando = valor;
  for (i=1; i<4; i++) cuales[i] = FALSE;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void PN3() {

/* Aumento la frecuencia de una sola periodica */

  int i;
  nat valor = 5;
  static int j;

  if (bm_ovl) {
	if (BCP[j].Ti - BCP[j].Ci <= 70) {
	      BCP[j].Ti = BCP[j].Ci;
	      paro = TRUE;
	    }
	else
	   BCP[j].Ti -= 70;   /* Aumento la frecuencia periodo */

  hasta_cuando = maximo();
  return;
  }

  /* 1er. test */
  for (i=0; i<5; i++) {
    valor *= (random(7)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti)*3/5+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks= cant_per = i;
  j=random(5); if (j==5) j = 4;
  bm_ovl = TRUE;
  hasta_cuando = valor;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void PN4() {
/* Agregar de a una tarea a la vez. */

  static int pos = 5;
  nat valor = 5;
  int i, j;
  static nat mcd;

  if (bm_ovl) {
	hasta_cuando = maximo();
	valor = mcd * (random(2)+1);
	BCP[pos].Ti = valor;
	BCP[pos].Ci = random(BCP[pos].Ti-1)/10+1;
	BCP[pos].criticidad = (float) random(30000)/30000.0;
	BCP[pos].tipo = PER;
	BCP[pos].comienzo = 0;
	pos++;
	nro_tasks++; cant_per++;
	if (nro_tasks > 30) paro = TRUE;
	return;
  }

  for (i=0; i<5; i++) {
    BCP[i].Ti = random(5)+1*10;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks= cant_per = i;
  bm_ovl = TRUE;
  mcd = calc_mcd(i);
  hasta_cuando = maximo();
}

/*********************************** AA ***********************************/
void AA1() {

/* 5 periodicas armo'nicas, 5 aperiodicas. Disminuyo la frecuencia de
tareas perio'dicas en c/corrida. Empiezo con sistemas sobrecargados, y voy
relajando la carga */

 nat i, j;

  if (bm_ovl) {
	rest_inf_ap();
	PA2();
	guardar_inf_ap();
	return;
  }

  /* 1er. test */
  PA2();           /* Uso el mismo PA2 para generar las tareas perio'dicas */

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando)+1;
    BCP[i].Ci = random(BCP[i].Ti)/8+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  nro_tasks = i;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AA2() {
  /* 5 periodicas armo'nicas, 5 aperiodicas. Agrego periodicas */

  static int pos = 10;
  int i, j;
  static nat valor;

  if (bm_ovl) {   /* Agrego de a una periodica */
	rest_inf_ap();
	valor *= (random(2)+1);
	BCP[pos].Ti = valor;
	BCP[pos].Ci = random(valor)/10+1;
	BCP[pos].criticidad = (float) random(30000)/30000.0;
	BCP[pos].tipo = PER;
	BCP[pos].comienzo = 0;
	pos++;
	nro_tasks++;
	if (nro_tasks > 30 || valor > 32000) {
	     if (valor > 32000) BCP[pos].Ci = random(32000)+1;
	     paro = TRUE;
	}
	guardar_inf_ap();
	hasta_cuando = valor;
	return;
  }

  /* 1er. test */
  valor = 5;
  for (i=0; i<5; i++) {   /* 5 tareas armo'nicas */
    valor *= (random(2)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = valor/15+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = 5;
  /* mcd = calc_mcd(nro_tasks); */
  hasta_cuando = valor;

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/15+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  valor = hasta_cuando;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AA3() {
 nat i, j;
 static nat valor;

 /* 5 perio'dicas armo'nicas. 5 aperio'dicas. Voy achicando las metas de las
 aperio'dicas */

  if (bm_ovl) {   /* Disminuyo la meta de las aperiodicas. */
	j=random(5)+5; if (j==10) j=9;
	rest_inf_ap();
	if (BCP[j].Ti <= 10) {
	    BCP[j].Ti = 10;
	    paro = TRUE;
	    guardar_inf_ap();
	    return;
	}
	BCP[j].Ti-=10;
	if (BCP[j].Ci + 10 > BCP[j].Ti) paro = TRUE;
	guardar_inf_ap();
	return;
  }

  /* 1er. test */
  valor = 5;
  for (i=0; i<5; i++) {   /* 5 tareas armo'nicas */
    valor *= (random(2)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(valor)/15+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = 5;
  hasta_cuando = valor;

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/15+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AA4() {
  /* 5 PER armo'nicas, 5 aperiodicas. Agrego aperiodicas. */

  static int pos = 10;
  int i, j;
  static nat valor;

  if (bm_ovl) {   /* Agrego una nueva aperiodica */
	rest_inf_ap();
	BCP[pos].Ti = random(hasta_cuando/3)/5+1;
	BCP[pos].Ci = random(BCP[pos].Ti)/10+1;
	BCP[pos].criticidad = (float) random(30000)/30000.0;
	BCP[pos].comienzo = random(hasta_cuando-BCP[pos].Ti);
	BCP[pos].tipo = APER;
	pos++;
	nro_tasks++;
	if (nro_tasks > 30) paro = TRUE;
	guardar_inf_ap();
	return;
  }

  /* 1er. test */
  valor = 5;
  for (i=0; i<5; i++) {   /* 5 tareas armo'nicas */
    valor *= (random(2)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(valor)/15+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks=cant_per=5;
  hasta_cuando = valor;

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/15+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AA5() {

/* 5 perio'dicas armo'nicas. 5 aperio'dicas. Voy incrementando el Ci a las
   aperiodicas. */
 nat valor = 5, i, j;

  if (bm_ovl) {
	rest_inf_ap();
	j=random(5)+5; if (j==10) j = 9;
	BCP[j].Ci += 40;
	if (BCP[j].Ci + 40 > BCP[j].Ti ) {
	    BCP[j].Ci = BCP[j].Ti;
	    paro = TRUE;
	}
	guardar_inf_ap();
	return;
  }

  /* 1er. test */
  for (i=0; i<5; i++) {  /* 5 periodicas */
    valor *= (random(5)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = i;
  hasta_cuando = valor;

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}


/*********************************** AN ***********************************/
void AN1() {

/* 5 aperiodicas,  5 PER no armonicas. Aumento el Ti de las periodicas */
 nat i, j;
 static nat valor = 5;

  if (bm_ovl) {
	j=random(5); if (j==5) j=4;
	rest_inf_ap();
	if (BCP[j].Ti <= 5) {
	    BCP[j].Ti = 5;
	    paro = TRUE;
	    guardar_inf_ap();
	    return;
	}
	BCP[j].Ti-=5;
	if (BCP[j].Ci + 5 > BCP[j].Ti) {
	     paro = TRUE;
	     BCP[j].Ci = BCP[j].Ti;
	}
	hasta_cuando = maximo();
	guardar_inf_ap();
	return;
  }

  /* 1er. test */
  for (i=0; i<5; i++) {  /* 5 periodicas */
      valor *= (random(5)+1);
      BCP[i].Ti = valor;
      BCP[i].Ci = random(BCP[i].Ti)/10+1;
      BCP[i].criticidad = (float) random(30000)/30000.0;
      BCP[i].tipo = PER;
  }
  nro_tasks = cant_per =i;
  hasta_cuando = valor;
/*  mcd = calc_mcd(nro_tasks); */

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}
/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AN2() {
  /* 5 perio'dicas no armo'nicas, 5 aperiodicas. Voy agregando de a una
     perio'dica no armo'nica */

  static int pos = 10;
  nat valor = 5;
  int i, j;
  static nat mcd;

  if (bm_ovl) {   /* Agrego periodicas */
	rest_inf_ap();
	valor = mcd * (random(5)+1);
	BCP[pos].Ti = valor;
	BCP[pos].Ci = random(BCP[pos].Ti-1)/10+1;
	BCP[pos].criticidad = (float) random(30000)/30000.0;
	BCP[pos].tipo = PER;
	BCP[pos].comienzo = 0;
	pos++;
	nro_tasks++;
	if (nro_tasks > 25) paro = TRUE;
	guardar_inf_ap();
	return;
  }

  for (i=0; i<5; i++) {  /* 5 perio'dicas */
    valor *= (random(5)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per =i;
  hasta_cuando = maximo();
  mcd = calc_mcd(nro_tasks);

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AN3() {
 nat valor = 5, i, j;

 /* 5 perio'dicas no armo'nicas; 5 aperio'dicas. Disminuyo la meta de las
    aperio'dicas */

  if (bm_ovl) {   /* Aumento la frecuencia de las aperiodicas. */
	j=random(5)+5; if (j==10) j=9;
	rest_inf_ap();
	if (BCP[j].Ti < 10) {
	    BCP[j].Ti = 5;
	    paro = TRUE;
	    guardar_inf_ap();
	    return;
	}
	BCP[j].Ti-=5;
	if (BCP[j].Ti - BCP[j].Ci <= 5) {
		paro = TRUE;
		BCP[j].Ti = BCP[j].Ci;
	}
	guardar_inf_ap();
	return;
  }

  /* 1er. test */
  for (i=0; i<5; i++) {
    valor *= (random(3)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = i;
  hasta_cuando = valor;

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AN4() {
 /* 5 perio'dicas no armo'nicas, 5 aperiodicas. Agrego tareas aperio'dicas */

  static int pos = 10;
  nat valor = 5;
  int i, j;
  static nat mcd;

  if (bm_ovl) {   /* Agrego una nueva */
	rest_inf_ap();
	valor = mcd * (random(4)+1);
	BCP[pos].Ti = valor;
	BCP[pos].Ci = random(BCP[pos].Ti)/10+1;
	BCP[pos].criticidad = (float) random(30000)/30000.0;
	BCP[pos].comienzo = random(hasta_cuando-BCP[pos].Ti);
	BCP[pos].tipo = APER;
	pos++;
	nro_tasks++;
	if (nro_tasks > 25) paro = TRUE;
	guardar_inf_ap();
	return;
  }

  for (i=0; i<5; i++) {
    valor *= (random(5)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks=cant_per=i;
  mcd = calc_mcd(nro_tasks);
  hasta_cuando = maximo();

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void AN5() {

/* 5 perio'dicas no armo'nicas, 5 aperio'dicas. Voy incrementando el Ci a las
 aperiodicas. */
 nat valor = 5, i, j;

  if (bm_ovl) {
	rest_inf_ap();
	j=random(5)+5; if (j==10) j=9;
	BCP[j].Ci += 50;
	if (BCP[j].Ci + 50 > BCP[j].Ti ) {
		 BCP[j].Ci = BCP[j].Ti;
		 paro = TRUE;
	}
	guardar_inf_ap();
	return;
  }

  /* 1er. test */
  for (i=0; i<5; i++) {  /* 5 periodicas */
    valor *= (random(5)+1);
    BCP[i].Ti = valor;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].tipo = PER;
  }
  nro_tasks = cant_per = i;
  hasta_cuando = maximo();

  for (i=5; i<10; i++) { /* 5 aperiodicas */
    BCP[i].Ti = random(hasta_cuando-1)+1;
    BCP[i].Ci = random(BCP[i].Ti)/10+1;
    BCP[i].criticidad = (float) random(30000)/30000.0;
    BCP[i].comienzo = random(hasta_cuando-BCP[i].Ti);
    BCP[i].tipo = APER;
  }
  bm_ovl = TRUE;
  nro_tasks = i;
  guardar_inf_ap();
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void inicializar_resto_tabla() {

  int i;
  char numero[10];

  for (i=0; i<nro_tasks; i++) {
      strcpy(BCP[i].nombre, "T");
      itoa(i, numero, 10);
      strcat(BCP[i].nombre, numero);
      if (BCP[i].tipo == PER) BCP[i].comienzo = 0; /* Con otros algoritmos: random */
      BCP[i].tpo_restante = BCP[i].Ci;
      BCP[i].perdi_meta = FALSE;
      BCP[i].en_crit = TRUE; /* Estoy en el conj. critico */

      if (BCP[i].comienzo == 0) {
	BCP[i].estado = LISTO;
	BCP[i].meta = BCP[i].Ti;
	}
      else
	{
	BCP[i].estado = A_COM;
	BCP[i].meta = BCP[i].comienzo+BCP[i].Ti;
	}
  }
}

void cinco_tareas() {   /* cinco tareas periodicas */
 int i;

    for (i=0; i<5; i++)
      if (BCP[i].Ti != 1)
	 BCP[i].Ti = BCP[i].Ti*3/4;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
nat maximo() {
   /* Recorrer. Buscar el de maximo perodo */
   int i, j, k;
   nat primos[15] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47 };
   nat aux[200], frec_max[15], frec_loc[15];
   unsigned long mcm = 1;

   k = 0;
   for (i=0; i<nro_tasks; i++)    /* genero vector auxiliar */
	if (BCP[i].tipo == PER) /* mcm de las perio'dicas */
	      aux[k++] = BCP[i].Ti;  /* K: cantidad de perio'dicas */

   for (i=0; i<15; i++)
	frec_max[i] = frec_loc[i] = 0;

   for (i=0; i<k; i++) {
	j = 0;

	while (j<15 && aux[i] != 1) {   /* Busco multiplos de los primos. */

	    if (aux[i] % primos[j] == 0) { /* es mu'ltiplo */
		frec_loc[j]++;   /* Averiguo a la cuanto esta'n elevados. */
		aux[i] /= (primos[j]);
	    } /* if */
	    else
		j++;
	} /* while */

	if (aux[i] != 0)  /* No es mu'ltiplo de todos los primos */
	   mcm *= aux[i];

	for (j=0; j<15; j++) {
	   if (frec_loc[j] > frec_max[j])
	     frec_max[j] = frec_loc[j];
	   frec_loc[j] = 0;
	}
   } /* for */

   for (j=0; j<15; j++)
	if (frec_max[j] != 0) mcm *= (nat) pow((double) primos[j],(double) frec_max[j]);

   if (mcm > 65535L) return 65535;
   else return (nat) mcm;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
nat calc_mcd(int cant) {
  nat mcd = 0;
  int i;
  boolean encontre;

  for (i=1; i<cant; i++)
	if (BCP[i].Ti <BCP[mcd].Ti) mcd = i;

  mcd = BCP[mcd].Ti;

  encontre = 0;
  while (!encontre && mcd) {
    encontre = 1;
    for (i=0; i<cant && encontre; i++) {
	if (BCP[i].Ti % mcd != 0) {
		encontre = 0;
		mcd--;
	}
    }
  }

  if (!encontre)
	return 1;
  else
	return mcd;
}

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */
void guardar_inf_ap() {  /* Salva la tabla */
  int i, j;

  cant_aper = 0;
  for (i=0; i<nro_tasks; i++)
	memcpy (&AUX[cant_aper++], &BCP[i], sizeof(struct bcp));
  AUX[cant_aper].nombre[0]='*';
}

void rest_inf_ap() {   /* Recupera */
  int i, j;

  i = j = 0;
  while (AUX[j].nombre[0] != '*')
    memcpy (&BCP[i++], &AUX[j++], sizeof(struct bcp));
  nro_tasks = i;
}

/* ---------------------        Simulador       --------------------------- */
void simulador() {

  register int pos, i;
  register boolean imprimir = TRUE;

    if (imp_c) printf("\n---------------------------------------------------\n");
#ifdef AGAPE
    if (imp_c) fileAgape = fopen("agape.tmp","wt");
#endif
    for (hora=0; hora< hasta_cuando; hora++) {
#ifdef AGAPE
      if (kbhit())
		if (getch()==TECLA_EXIT)
		{
			tecla = TRUE;
			break;
		}
#endif
      replanificar();       /* Replanifico las tareas que sean necesarias */
      pos = buscar_prim_lista();        /* scheduler */

      if (pos == -1) {  /* No hay procesos listos */
      /* Busco en la tabla, que esta' ordenada por criticidad. Si existe una
	 demorada, aprovecho que es un tiempo ocioso para ejecutarla */
	for (i=0; i<nro_tasks; i++)
	    if (BCP[i].estado == DEMORADO) {
		   pos = i;
		   break;
	    }
	}

      if (pos != anterior && pos != -1
	 || (pos == anterior && BCP[pos].tpo_restante == BCP[pos].Ci) )
#ifndef AGAPE
         if (imp_c) printf("\n%s, hora: %u", BCP[pos].nombre, hora);
#else
        if (imp_c) {
			horaAnt = horaActual;
			horaActual = hora;
            printf("\n%s, hora: %u", BCP[pos].nombre, hora);
            sprintf(lineaAgape,"1,%s,%u", BCP[pos].nombre, hora);
			lineaRemo = "0";
        }
#endif
	   if (pos != anterior && anterior != -1) metricas.c_contexto++;

	   if (pos == -1) {  /* No hay procesos listos ni demorados */
	     metricas.idle_time++;
	     if (imprimir) {    /* Evito imprimir "Idle time" en c/ciclo */
           if (imp_c) printf("\nIdle time");
		  imprimir = FALSE;
	       } /* if imprimir */
	   } /* if pos */
	   else {  /* Hay procesos listos */
	     imprimir = TRUE;
	     if (pos != anterior && BCP[anterior].tpo_restante != 0
	       && BCP[anterior].tpo_restante != BCP[anterior].Ci) {
		if (anterior != -1) {
		    metricas.remocion++;
#ifndef AGAPE
            if (imp_c) printf(" (Remocin %s)", BCP[anterior].nombre);
#else
            if (imp_c) {
                printf(" (Remocin %s)", BCP[anterior].nombre);
				fprintf(fileAgape,"1,%s,%u,%u,%s\n",BCP[anterior].nombre,horaAnt,hora,lineaRemo);
                lineaRemo = "1";
            }
#endif
		} /* if anterior */
	     } /* if pos */
	  } /* else */
	  anterior = pos;  /* Simulo ejecucio'n */
	  if (--BCP[pos].tpo_restante == 0)  { /* termino' su ejecucio'n */
	      verificar_metas(pos);   /* Termino' la instancia: miro que paso' */
	      if (BCP[pos].tipo == PER)         /* Lo paso a estado Bloqueado */
		  BCP[pos].estado = BLOQUEADO;
	      else
		    /* Tarea esporadica: desaparece */
		borrar_esp(pos);
	 }
#ifdef X
      simular_ejec(pos);  /* Ci-1 para simular ejecucio'n de una unidad */
#endif
       } /* for */

    if (imp_r) imprimir_resultados();
    guardar_resultados();
#ifdef AGAPE
    fclose(fileAgape);
#endif
}

/* -------------------  Funciones genericas del simulador ----------------- */

#ifdef X
void simular_ejec(int pos) {
}

#endif

void borrar_esp(int pos) { /* Las espora'dicas vuelan */
  int i;

  nro_tasks--;
  for (i=pos; i< nro_tasks; i++)
	memcpy (&BCP[i], &BCP[i+1], sizeof(struct bcp));
  verificar_planif();
  metricas.overload = overloaded;
}

void replanificar() {
  register nat pos, ci_actual;
  double gamma(int);
  register double ran; /* Variable random con distribucio'n gamma */

  for (pos=0; pos<nro_tasks; pos++)  {
      /* Miro si hay que replanificar. Se replanifica cuando: a) la tarea es
      perio'dica y paso' un peri'odo (debe haber terminado de ejecutar y estar
      bloqueada, porque sino ya esta' en estado de Listo ); b) Aperio'dicas o
      comienzo demorado, y llego' la hora de comienzo */

      if ( (hora-BCP[pos].comienzo) % BCP[pos].Ti == 0 && BCP[pos].tipo == PER
	 && BCP[pos].estado == BLOQUEADO ||
	    (BCP[pos].estado == A_COM && hora == BCP[pos].comienzo))  {
			BCP[pos].estado = LISTO;
      }

      if ( ((hora-BCP[pos].comienzo) % BCP[pos].Ti == 0 && BCP[pos].tipo == PER) ||
	       hora == BCP[pos].comienzo)  {
      /* Aca' no considero el estado en que esta' el proceso, porque si llego'
      su hora de comenzar hay que calcular las me'tricas este' en el estado
      que este' */
	   metricas.max_gr_pond+= BCP[pos].criticidad; /* Empieza una nueva instancia: acumulo criticidades */
	   if (BCP[pos].tipo == APER)
	      metricas.max_gr_pond_aper += BCP[pos].criticidad;
	   else
	      metricas.max_gr_pond_per += BCP[pos].criticidad;

	  if (hora == BCP[pos].comienzo && hora != 0)
	  /* Al empezar algo demorado hay que verificar la planif. on-line */
		verificar_planif();
	  if (overloaded) {
		metricas.overload = TRUE;
		set_conj_crit();
	  }
      }

      /* Perdi meta?: me entero mirando si en el momento de la meta au'n le
      falta ejecutar. Actualizo las me'tricas */
      if (hora >= BCP[pos].meta && BCP[pos].tpo_restante > 0 && !BCP[pos].perdi_meta) {
#ifndef AGAPE
     if (imp_c) printf(" (%u:%s perdio' meta)", hora, BCP[pos].nombre);
#else
    if (imp_c) {
        printf(" (%u:%s perdio' meta)", hora, BCP[pos].nombre);
        fprintf(fileAgape,"2,%s,%u\n", BCP[pos].nombre, hora);
    }
#endif
	 metricas.metas_perd++;
	 metricas.nr_metas++;
	 BCP[pos].perdi_meta = TRUE;
	 if (BCP[pos].tipo == APER) {
	    metricas.metas_aper++;
	    metricas.nr_aper++;
	 }
	 else {
	    metricas.metas_per++;
	    metricas.nr_per++;
	 }
      }

      if (hora > BCP[pos].comienzo &&
	((hora-BCP[pos].comienzo) % BCP[pos].Ti == 0) && BCP[pos].tipo == PER
	   && (BCP[pos].estado == LISTO || BCP[pos].estado == DEMORADO) )  {
      /* Si la tarea empezo' a correr y es perio'dica, y es su momento de
      replanificaci'on, le doy nuevo tiempo de CPU (sumo al tiempo restante
      por ejecutar, el peor caso de ejecucio'n o el tiempo aleatorio de eje-
      cucio'n, segu'n el algoritmo utilizado */

	BCP[pos].meta += BCP[pos].Ti;  /* Calculo la meta */
	if (!ci_variable)  /* El Ci es fijo: lo sumo al tpo. restante */
		BCP[pos].tpo_restante += BCP[pos].Ci;
	else {
	   ran = gamma(2);
	   if (ran > 10.0) ran = 10.0;

	   switch(que_gama) { /* Segun que gama uso, genero el valor random */
	      case CERCA_CERO:
		   ci_actual = ran*BCP[pos].Ci/10.0;
		   if (ci_actual < 1.0) ci_actual = 1;
		   break;

	      case CERCA_PEOR:

	    /* La gamma de 2 devuelve una variable aleatoria con media en
	    2, y el peor caso es de 10: para transformarla en una variable
	    entre 0 y 1, para hacer el Ci proporcional a la variable, lo
	    divido por 10. Como quiero invertir la funcio'n, y hacer que
	    la mayori'a de los valores este'n cerca del peor caso, resto
	    el Ci. Cuando pruebe el caso bueno, ci_actual = ran/10*Ci */

		ci_actual = BCP[pos].Ci - ran/10.0*BCP[pos].Ci;
		if (ci_actual < 1.0) ci_actual = 1;
		break;
	    } /* switch */
	    BCP[pos].tpo_restante += ci_actual;
	}
	BCP[pos].perdi_meta = FALSE;
      }
   } /* for */
}

double gamma(int a) {
 int j;
 double am, e, s, v1, v2, x, y, aux;

 if (a < 6) {
    x = 1.0;
    for (j=1; j<a; j++) x *= (double) random(32767)/32767.;
    if (x == 0) x = 1.0;
    x -= log(x);
 }
 else {
  do {
    do {
      do { v1 = 2.0 * (double) (random(32767)/32767.)- 1.0;
	   v2 = 2.0 * (double) (random(32767)/32767.)- 1.0;
      } while (v1*v1 + v2*v2 > 1.0);
      y = v2/v1;
      am = a-1;
      s = sqrt(2.0*am +1.0);
      x = s * y + am;
    } while (x <= 0.0);
    e = (1.0+y*y) * exp(am*log(x/am)-s*y);
  } while ((double) (random(32767)/32767.) > e);
 }
 return x;
}

void verificar_metas(int pos) { /* Actualizo me'tricas */

/* Esto deberi'a hacerse en el momento de terminar una instancia. VER */

   if (anterior == -1)
	   suma_previos = 0;
   else
	   suma_previos += BCP[anterior].tpo_restante;


   metricas.nr_metas++;                   /* Una meta ma's */

   if (BCP[pos].tipo == APER)
	metricas.nr_aper++;
   else
	metricas.nr_per++;

#ifndef AGAPE
   if (imp_c) printf(" Fin: %u", hora+1);
#else
    if (imp_c) {
        printf(" Fin: %u", hora+1);
        sprintf(lineaFin,"%u",hora+1);
    	fprintf(fileAgape,"%s,%s,%s\n",lineaAgape,lineaFin,lineaRemo);
    }
#endif

   BCP[pos].perdi_meta = FALSE;

   if (hora < BCP[pos].meta) { /* Llegue' a tiempo */
       metricas.g_r++;
       metricas.g_r_pond += BCP[pos].criticidad;

       if (BCP[pos].tipo == APER) {   /* Veo de que' tipo es la tarea */
	    metricas.g_r_aper++;
	    metricas.g_r_aper_pond += BCP[pos].criticidad;
       }  /* if BCP */
       else {
	    metricas.g_r_per++;
	    metricas.g_r_per_pond += BCP[pos].criticidad;
       } /* else */
   } /* hora */
}  /* funcin */


/* --------------------------- Tests de planificabilidad ----------------- */
struct {nat Ti, Ci; } dat_c[200];
nat nro_calc;

int planif_teo1(void) { /* Analizo predictibilidad usando el Teo1. Si no
  cumple, uso el Teo3 */

  int planif_teo3(void);
  void copiar_datos(void);

    copiar_datos();     /* Copia Ci's y Ti's de los que tienen sentido */
    metricas.uso_cpu = calc_uso_cpu(nro_calc);
    if (nro_calc == 0) return 0; /* No hay nada para calcular */
    metricas.Un = (float) nro_calc * (float) (pow(2.0, 1.0/(float)nro_calc) -1.0);

    overloaded = (metricas.uso_cpu > metricas.Un) ? TRUE : FALSE;
    if (overloaded) planif_teo3();
    return 0;
}


int planif_teo3(void) { /* teorema 3 */
  int i,k,l,Ri;
  float valor, min=100.0;

  overloaded = FALSE;

  for (i=1; i<=nro_calc; i++) {
     min = 100.0;
     for (k=1; k<=i; k++) {
	Ri = (int) floor ( (double) (dat_c[i-1].Ti/dat_c[k-1].Ti) );
	for (l=1; l<=Ri; l++)
		valor = calc_sumatoria(i,k,l);
	min = (valor < min)? valor:min;
	} /* for k */
     if (min > 1.0) {
	overloaded = TRUE;
	metricas.sha = min;
	return 0; /* Encontro' uno que no cumple la condicio'n: me voy */
     }
  } /* for i */
  metricas.sha = min;
  return 0;
}


int planif_1(void) { /* Verifica si Sum < 1*/
  void copiar_datos();

    copiar_datos();
    metricas.uso_cpu = calc_uso_cpu(nro_calc);
    overloaded = (metricas.uso_cpu > 1.0)? TRUE : FALSE;
    return 0;
}

int planif_ci_var(void) {  /* Calcula planificabilidad con mi test */
   float term2, qj;
   int j;

   ci_variable = TRUE;

   planif_teo1();     /* Calculo sumatoria y Un */
   /* Esto estaba aca'. Lo muevo al control de fin de instancia
   if (anterior == -1)
	   suma_previos = 0;
   else
	   suma_previos += BCP[anterior].tpo_restante;
   */

   term2 = 0;

   for (j=0; j<nro_tasks; j++) {
      /* if (BCP[j].Ti == 0)
	 printf("Ti=%u\n", BCP[j].Ti); */
      if (BCP[j].tipo == APER) qj = 1.0;
      else qj = ceil((double) hasta_cuando/ (double) BCP[j].Ti) -
			ceil( (double) hora/ (double) BCP[j].Ti);
      term2 += qj * BCP[j].Ci;
   }

   if (suma_previos + term2 > (float) hasta_cuando)
	overloaded = TRUE;
   else
	overloaded = FALSE;
   return 0;
}


float calc_uso_cpu(unsigned int n) {
   float sum = 0.0;
   int i;
 
   for (i = 0; i < n; i++)
#ifdef X
     if (BCP[i].tipo == PER )  // Solo las periodicas
     if (BCP[i].tipo == PER || hora > dat_c[i].comienzo)  // Solo las periodicas
							// o las demoradas
#endif
      sum += (float) dat_c[i].Ci / (float) dat_c[i].Ti;
   return sum;
}

float calc_uso_per(unsigned int n) {
   float sum = 0.0;
   int i;

   for (i = 0; i < n; i++)
      sum += (float) dat_c[i].Ci / (float) dat_c[i].Ti;

   return sum;
}

float calc_sumatoria(int i, int k, int l) {
  int j;
  float term1, term2, term3, sum = 0.0;

  for (j=1; j<=i; j++) {
	term1 = 1.0 / ((float)l * (float)dat_c[k-1].Ti );
	term2 = (float) l * (float) dat_c[k-1].Ti/(float)dat_c[j-1].Ti;
	term3 = ceil ((double) term2);
	sum += dat_c[j-1].Ci * term1 * term3;
  }
  return sum;
}

void copiar_datos(void) {
 int i;

  nro_calc =0;
  for (i=0; i<nro_tasks; i++) {
	if (BCP[i].estado != A_COM && BCP[i].estado != DEMORADO) {
	   dat_c[nro_calc].Ti = BCP[i].Ti;
	   dat_c[nro_calc].Ci = BCP[i].Ci;
	   nro_calc++;
	}
  }
}

/* ---------------------------- Schedulers --------------------------- */

int buscar_tm(void) {
   /* Recorrer. Buscar el primero. Buscar por perodo */
   register unsigned int min = UINT_MAX;
   register int i, pos;

   for (i=0; i<nro_tasks; i++) {
      if (BCP[i].Ti < min && BCP[i].estado == LISTO) {
    min = BCP[i].Ti;
    pos = i;
      }
   }

   if (min == UINT_MAX)
      return(-1);          /* No hay tareas listas */
   else
      return(pos);
}

int buscar_edf(void) {
   register unsigned int min = UINT_MAX;
   register int i, pos;

   for (i=0; i<nro_tasks; i++) {
       if (BCP[i].meta < min && BCP[i].estado == LISTO) {
	    min = BCP[i].meta;
	    pos = i;
      }
   }
   if (min == UINT_MAX)
      return(-1);          /* No hay tareas listas */
   else
      return(pos);
}

int buscar_llf(void) {
   register unsigned int min = UINT_MAX;
   register int i, pos;

   for (i=0; i<nro_tasks; i++) {
      BCP[i].laxity = (BCP[i].meta - hora) - BCP[i].tpo_restante;
      if (BCP[i].laxity < min && BCP[i].estado == LISTO) {
    min = BCP[i].laxity;
    pos = i;
      }
   }
   if (min == UINT_MAX)
      return(-1);          /* No hay tareas listas */
   else
      return(pos);
}

int buscar_muf(void) {
   /* Hace una pasada con High, y LLF. Si no existe, lo mismo con Low */
   register unsigned int min = UINT_MAX;
   register int i, pos;

   for (i=0; i<nro_tasks; i++) {
    BCP[i].laxity = (BCP[i].meta - hora) - BCP[i].tpo_restante;
      if (BCP[i].laxity < min && BCP[i].estado == LISTO &&
	      BCP[i].criticidad > 0.5) {  /* Es alta */
	    min = BCP[i].laxity;
	    pos = i;
      }
   }
   if (min != UINT_MAX)
      return(pos);      /* Encontre' un High */

   for (i=0; i<nro_tasks; i++) {
      BCP[i].laxity = BCP[i].Ti - BCP[i].tpo_restante;
      if (BCP[i].laxity < min && BCP[i].estado == LISTO &&
	      BCP[i].criticidad <= 0.5) {  /* Es baja */
    min = BCP[i].laxity;
    pos = i;
      }
   }

   if (min == UINT_MAX)
      return(-1);          /* No hay tareas listas */
   else
      return(pos);
}

/* -----------------------------  Conjuntos crticos ------------------- */

int calc_crit(void) {  /* Calcula conjunto crtico de TM */
  register nat aux;
/*  nat busq, fin_linea=0;
  FILE *arch; */

/*  arch = fopen("est_crit.txt", "at"); */ /* Abro el archivo de estad de crit */
  aux = nro_tasks;

/*  busq = 0; */
  while (overloaded) {
/*     busq++; */
     nro_tasks--;
     BCP[nro_tasks].en_crit = FALSE;
     BCP[nro_tasks].estado = DEMORADO;
     verificar_planif();
  }
  nro_tasks = aux;
  /*
  fprintf(arch, "%f,", (float) busq/(float) nro_tasks);
  if (fin_linea++ % 10 == 0) fprintf(arch, "\n");
  fclose(arch);
  */
  return 0;
}

nada() {
  /* Funcion que no hace nada; para el caso de los alg. tradicionales */
  return 0;
}

/* ---------------------------- Inicializacin -------------------------- */
void inicializar_mediciones() {

    metricas.remocion = metricas.c_contexto = metricas.idle_time = 0;
    metricas.uso_cpu = metricas.Un = 0.0;
    metricas.nr_metas= metricas.nr_per = metricas.nr_aper = 0;
    metricas.metas_perd = metricas.metas_per = metricas.metas_aper = 0;
    metricas.g_r = metricas.g_r_per = metricas.g_r_aper=0;
    metricas.g_r_pond = metricas.g_r_per_pond = metricas.g_r_aper_pond=0.0;
    metricas.max_gr_pond = metricas.max_gr_pond_per = metricas.max_gr_pond_aper=0.0;

    metricas.overload = overloaded=FALSE;
}


void init(char *archi) {
  void ordenar_tabla(void);
  void inicializar_ci_variable();
//  int funcion_orden(const void *a, const void *b);

  if (archi[0] != NULL)
      get_test_vector(archi);
  else {
      gen_tbl_Hartstone();
      inicializar_resto_tabla();
  }
  ordenar_tabla();       /* Se ordena la tabla por criticidad */
  // qsort((void *) BCP, nro_tasks, sizeof(struct bcp), funcion_orden);
  if (ci_variable) inicializar_ci_variable(); /* Inicializo con ci variable */
  if (imp_t) mostrar_TBCP();
}

int funcion_orden(const void *a, const void *b) {
   return ((float *)a-(float *)b);
}

void inicializar_ci_variable() {
 register int pos;
 double gamma(int);
 double ran;
 nat ci_actual;

   for (pos =0; pos<nro_tasks; pos++) {
      ran = gamma(2);
      if (ran > 10.0) ran = 10.0;

      switch(que_gama) { /* Segun que gama uso, genero el valor random */
	   case CERCA_CERO:
	       ci_actual = ran*BCP[pos].Ci/10.0;
	       if (ci_actual < 1.0) ci_actual = 1;
	       break;

	   case CERCA_PEOR:

	   /* La gamma de 2 devuelve una variable aleatoria con media en
	    2, y el peor caso es de 10: para transformarla en una variable
	    entre 0 y 1, para hacer el Ci proporcional a la variable, lo
	    divido por 10. Como quiero invertir la funcio'n, y hacer que
	    la mayori'a de los valores este'n cerca del peor caso, resto
	    el Ci. Cuando pruebe el caso bueno, ci_actual = ran/10*Ci */

		ci_actual = BCP[pos].Ci - ran/10.0*BCP[pos].Ci;
		if (ci_actual < 1.0) ci_actual = 1;
		break;
	    } /* switch */
	    BCP[pos].tpo_restante = ci_actual;
	}
}

void ordenar_tabla(void) { /* Ordeno usando Shell. Ver el quicksort */
 int i, j, inc;
 struct bcp aux;
 boolean inter;

 inter = TRUE;
 inc = 0;

 while (inc < nro_tasks && inter) {
    inter = FALSE;
    for (j=0; j< nro_tasks-inc; j++)
	if (BCP[j].criticidad < BCP[j+1].criticidad) {
	     inter = TRUE;
	     memcpy(&aux, &BCP[j], sizeof(struct bcp));
	     memcpy(&BCP[j], &BCP[j+1], sizeof(struct bcp));
	     memcpy(&BCP[j+1], &aux, sizeof(struct bcp));
	}  /* if */
    inc++;
 } /* while */
} /* funcion */
 /*
 inc = 1;
 do {
    inc *= 3;
    inc++;
 } while (inc <= nro_tasks);

 do {
    inc /= 3;
    for (i = inc +1; i< nro_tasks; i++) {
       memcpy(&aux, &BCP[i], sizeof(struct bcp));
       j = i;
       while (BCP[j-inc].criticidad < aux.criticidad && j-inc>=0 ) {
	 memcpy(&BCP[j], &BCP[j-inc], sizeof(struct bcp));
	 j -= inc;
       }
       memcpy(&BCP[j], &aux, sizeof(struct bcp));
    }
 } while (inc > 1);
}
*/

int seleccionar_algoritmo(int numero, char *nombre) {
   /* Si vino un parmetro pidiendo slo un algoritmo, lo busco, y seteo
   sus funciones. Sino, voy devolviendo uno por uno por orden */

   if (nombre[0] != NULL)  /* hay un nombre: me pidieron slo un algoritmo */
      numero = buscar_alg(nombre);

   buscar_prim_lista = algs_plan[numero][0]; /* Tomo el algoritmo */
   verificar_planif = algs_plan[numero][1]; /* Tomo el clculo */
   set_conj_crit = algs_plan[numero][2];   /* Seteo la func. de conj. crit */
   return numero;
}

int buscar_alg(char *nombre) {
   int i = 0;

   /* Busca un algoritmo en la lista y devuelve su valor */

   while (strcmp(strupr(nombre), lista_alg[i])!=0 && i < MAX_ALG) /* No lo encuentro */
      i++;

   if (i==MAX_ALG) { /* Error */
      printf("Error de formato. Ingres un algoritmo inexistente\n",
	    "valores posibles: \n");
      for (i=0; i<MAX_ALG; i++)
       puts(lista_alg[i]);
      exit(-1);
   }
   return i;
}



void verif_args(int argc, char*argv[], char *alg, char*archi) {

   char opc;

   imp_c = imp_r = imp_t = FALSE;
   alg[0] = archi [0] = NULL;

   if (argc==1) return;

   while (argc-- != 1) {  /* Tomo todos los argumentos de atra's a adelante */
	opc = argv[argc][1];
	switch(opc) {
		case 'i':
		case 'I':
		   switch (argv[argc][3]) {

			case 'n':
			case 'N': break;

			case 'c':
			case 'C': imp_c = TRUE; break;

			case 'r':
			case 'R': imp_r = TRUE; break;

			case 't':
			case 'T': imp_t = TRUE; break;

			default : imp_r = imp_c = imp_t = TRUE;
			}
			break;
		case 'f': /* archivo */
		case 'F': strcpy(archi, &(argv[argc][3]));
			  break;
		case 'A': /* algoritmo */
		case 'a': strcpy(alg, &(argv[argc][3]));
			  strcpy(metricas.alg, alg);
			  break;

	       default: printf("Formato incorrecto. Debe ingresar \n");
	       printf("simul [-i:opcion de impresion] [[-<algoritmo>] -<archivo>] \n");
	       printf("Opciones de impresion: r [resultados], c [corridas], t [tablas], n [ninguno] \n");
		       exit(-1);

       }
   }
}


/* -----------------------------  Carga  -------------------------------- */

void get_test_vector(char *fname) {
   int i;
   boolean ill_task = FALSE;
   char *token;
   char test_name[MAX_STRING+1], tmp[MAX_STRING+1];     /* its name */
   char BLANKS[]= " \t\n";
   extern int errno;

   if((infile = fopen(fname, "rt" )) == NULL ){
      fprintf(stderr, "No puedo abrir el archivo de configuracin %s\n", fname);
      perror(strerror(errno));
      exit(-1);
   }

      /* Decido si es el archivo correcto */
   if(fgets(tmp, MAX_STRING-1, infile) !=NULL && strcmp(strupr(tmp),"ARCHIVO DE CONFIGURACION:\n") ){
      fprintf(stderr, "Chequear el archivo %s: posible error\n", fname);
      exit(-1);
   }

   /* Desde aqu se asume que el archivo no tiene errore */

   /* Salteo todo hasta la palabra clave 'start' */
   lookup("comienzo", ":=");
   lookup("Conjunto de tareas", ":=");
   token= strtok(NULL, "\n");

   while(*token==' ') token++;
   if(strlen(token) > 50){
      fprintf(stderr, "El nombre %s es ms largo que lo permitido (50 cars.)\n", token);
      exit(-1);
   }
   strcpy(test_name, token);

   lookup("TIEMPO DE SIMULACION", ":=");
   hasta_cuando = atoi(strtok(NULL, BLANKS));

   lookup("Numero de tareas", ":=");
   nro_tasks = atoi(strtok(NULL, BLANKS));

   lookup("Clase de Carga", ":=");
   token= strtok(NULL, "\n");

   lookup("Descripcion", ":");
   lookup("Nombre", BLANKS);
   lookup("Criticidad", BLANKS);
   lookup("Tipo", BLANKS);
   lookup("Hora_de_Comienzo", BLANKS);
   lookup("Ti", BLANKS);
   lookup("Ci", BLANKS);

   /* Completar la estructura de datos con informacin del archivo */

   for (i=0; i<nro_tasks; i++) {
   /* Nombre de la tarea */
      fgets(tmp, MAX_STRING-1, infile);
      token=strtok(tmp, ",");
      if(strlen(token) >MAX_NAME_LENGTH){
	    fprintf(stderr, "El nombre %s es mayor que lo permitido (%d cars.)\n", token, MAX_NAME_LENGTH);
	    exit(-1);
      }
      strcpy(BCP[i].nombre, token);


      BCP[i].criticidad = atof(strtok(NULL, ","));
      token=strtok(NULL," \t,");
      BCP[i].tipo = strcmp(strupr(token),"PER")? APER: PER;
      BCP[i].comienzo = atoi(strtok(NULL, ","));
      BCP[i].Ti = atoi(strtok(NULL, ","));
      BCP[i].Ci = BCP[i].tpo_restante = atoi(strtok(NULL, "."));
      BCP[i].en_crit = TRUE;       /* Esta en el conj. critico */

      if (BCP[i].comienzo == 0) {
	BCP[i].estado = LISTO;
	BCP[i].meta = BCP[i].Ti;
	}
      else
	{
	BCP[i].estado = A_COM;
	BCP[i].meta = BCP[i].comienzo+BCP[i].Ti;
	}

      if(BCP[i].Ci <1 || BCP[i].Ci > BCP[i].Ti)
			ill_task=TRUE;

      if(ill_task){
	 fprintf(stderr, "Tarea de entrada errnea (nmero %d) en %s\n\n", i, fname);
	 exit(-1);
		} /* if */
	} /* for */
	/* Saltear el resto h/ el fin */
      lookup("fin", ".");
      fclose(infile);
}

void lookup(char *target, char *seps) {
	char *token;
	char test_name[MAX_STRING+1], tmp[MAX_STRING+1];

	do {
		if ((token = strtok(NULL,seps)) == NULL){
			do
				fgets(tmp, MAX_STRING-1, infile);
	 while (*tmp==';');

    token=strtok(tmp, seps);
      }
      token= strupr(token);
   } while (strcmp(token, strupr(target)) && !feof(infile));

   if (feof (infile)){
      fprintf (stderr, "EOF mientras se buscaba '%s'\n", target);
      exit(-1);
   }
}


/* -------------------- Impresiones y generacin de resultados ------------- */

void imprimir_resultados() {
      printf("\n------------------------------------------------");
      printf("\nResultados: \nAlgoritmo:  %s\n", metricas.alg);
		printf("Remociones: %10.5g, Cambios de contexto: %10.5g \n",
			(float) metricas.remocion/(float) hasta_cuando,
			(float) metricas.c_contexto/ (float) hasta_cuando);
      printf("Uso CPU: %10.5g, U(n): %10.5g, Sha: %10.5g\n", metricas.uso_cpu, metricas.Un, metricas.sha);
      printf("Overload: %s, Total metas: %u, ", (overloaded) ? "Si":"No",
			 metricas.nr_metas);
      printf("Idle time = %10.5g \n", (float) metricas.idle_time/ (float) hasta_cuando);

      if (metricas.nr_metas != 0) {
		 printf("G.R.     : %10.5g, ", (float) metricas.g_r / (float) metricas.nr_metas);
		 printf("G.R. Pond: %10.5g \n", metricas.g_r_pond/(float) metricas.max_gr_pond);
		}

      if (metricas.nr_per != 0)
		 printf("G.R. Per.: %10.5g, G.R. Pond. Per.: %10.5g\n", (float) metricas.g_r_per/ (float) metricas.nr_per,
			 metricas.g_r_per_pond/ (float) metricas.max_gr_pond_per);

      if (metricas.nr_aper != 0)
		 printf("G.R. Aper: %10.5g, G.R. Pond. Aper %10.5g \n", (float) metricas.g_r_aper/ (float) metricas.nr_aper,
			metricas.g_r_aper_pond/ (float) metricas.max_gr_pond_aper);

      printf("Metas perdidas = %u, Periodicas: %u, Aper: %u\n\n",
		 metricas.metas_perd, metricas.metas_per, metricas.metas_aper);
}


void guardar_resultados() {
	fprintf(res,"%5s,", metricas.alg);
	fprintf(res,"%02u,", clase);
	fprintf(res,"%g,%g,", (float) metricas.remocion/ (float) hasta_cuando,
		(float) metricas.c_contexto/ (float) hasta_cuando);
	fprintf(res,"%g,%g,", metricas.uso_cpu, metricas.Un);
	fprintf(res,"%s,%u,", (overloaded) ? "Si":"No", metricas.nr_metas);
	fprintf(res,"%g,", (float) metricas.idle_time/ (float) hasta_cuando);
	if (metricas.nr_metas != 0) {
		fprintf(res,"%g,", (float) metricas.g_r / (float) metricas.nr_metas);
		fprintf(res,"%g,", (float) metricas.g_r_pond / (float) metricas.max_gr_pond);
	}
	else
		fprintf(res,"%g,%g,", 2.0, 2.0);

	if (metricas.nr_per != 0)
		fprintf(res,"%g,%g,", (float) metricas.g_r_per/ (float) metricas.nr_per,
			(float) metricas.g_r_per_pond/ (float) metricas.max_gr_pond_per);
	else
		fprintf(res,"%g,%g,", 2., 2.);

	if (metricas.nr_aper != 0)
		fprintf(res,"%g,%g,", (float) metricas.g_r_aper/ (float) metricas.nr_aper,
			(float) metricas.g_r_aper_pond/ (float) metricas.max_gr_pond_aper);
	else
		fprintf(res,"%f,%f,", 2., 2.);
		fprintf(res,"%u,%u,%u\n",metricas.metas_perd, metricas.metas_per, metricas.metas_aper);
}

void salvar_TBCP() {
 int i, j;

 j = 0;
 for (i=0; i<nro_tasks; i++)
	memcpy (&AUX2[j++], &BCP[i], sizeof(struct bcp));
 AUX2[j].nombre[0] = '*';
}

void restaurar_TBCP() {
  int i, j;

  i = j = 0;
  while (AUX2[j].nombre[0] != '*')
    memcpy (&BCP[i++], &AUX2[j++], sizeof(struct bcp));
  nro_tasks = i;
}

void mostrar_TBCP() {
  int i;

  printf("\n----------------------------------------------------\n");
  printf("   Tarea     Ti     Ci   Comienzo  Criticidad   Tipo \n");
  printf("------------------------------------------------------\n");

  for (i=0; i<nro_tasks; i++) {
	printf("%-10s   %5u  %5u  %5u %-10.5g  %10s\n",
		BCP[i].nombre, BCP[i].Ti, BCP[i].Ci, BCP[i].comienzo,
		/* (BCP[i].criticidad == HIGH)? "High": "Low", */
		BCP[i].criticidad,
		(BCP[i].tipo == PER)? " Periodica":"Aperiodica");
  }
}
